// Selection using a combo box
// This example shows the basic process for creating a combo
// box. An array with the names of the weekdays is entered in
// the combo box. A code block is also registered in the instance
// variable :dataLink that assigns the currently selected item
// in the entry field of the combo box to a LOCAL variable.

#include "Appevent.ch"
#include "Xbp.ch"

PROCEDURE Main
   LOCAL nEvent, mp1, mp2, oXbp, bAction
   LOCAL oCombo, i, aDays, cDay := "Monday"

   SetColor("N/W")
   CLS

   aDays := { "Monday" , "Tuesday"  , "Wednesday", "Thursday", ;
              "Friday" , "Saturday" , "Sunday" }
   // Create combo box with drop down list box
   oCombo      := XbpCombobox():new()
   oCombo:type := XBPCOMBO_SIMPLE
   oCombo:create( ,, {50, 100}, {200, 150} )

   // Link data from entry field to LOCAL variable
   oCombo:XbpSLE:dataLink := {|x| IIf( x==NIL, cDay, cDay := x ) }
   oCombo:XbpSLE:setData()

   // Code block for selection:
   //  - assign to LOCAL variable using :getData()
   //  - display LOCAL variable using DispoutAt()
   bAction := {|mp1, mp2, obj| obj:XbpSLE:getData(), ;
               DispoutAt( MaxRow(), 0, PadR(cDay,20) ) }

   // Assign code block for selection with Up and Down keys
   oCombo:ItemMarked := bAction

   // Assign code block for selection by left mouse click in list box
   oCombo:ItemSelected := bAction

   // Copy data from array to combo box, then discard array
   FOR i:=1 TO 7
      oCombo:addItem( aDays[i] )
   NEXT
   aDays := NIL

   // Event loop
   nEvent := 0
   DO WHILE nEvent <> xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN
